;*
;* FileName:   pashead.inc
;* $Source: E:/usr/src/c-code/pascal/RCS/LIB/pashead.inc,v $
;* $Author: wjw $
;* $Date: 1993/11/03 15:54:52 $
;* $Locker: wjw $
;* $State: Exp $
;* $Revision: 1.1 $
;* Description:
;*      Part of the runtime library which comes with PASCAL for OS/2
;*      
;*
;* History:
;*      First created by Willem Jan Withagen ( wjw@eb.ele.tue.nl ),
;*                    on Mon July 26 23:30:03 MET 1993
;* Copyright:
;*      Copyright (c) 1993 by Willem Jan Withagen and 
;*                      Digital Information Systems group, TUE
;*      For copying and distribution information see the file COPYRIGHT.
;*
;* 
; ASM code to be used in every module assembled.
.NOLIST
; define the default used segments
; and give them a name.
CODE    SEGMENT PAGE PUBLIC FLAT 'CODE'
CODE    ENDS

DATA    SEGMENT PAGE PUBLIC FLAT 'DATA'
DATA    ENDS

CONST   SEGMENT PAGE PUBLIC FLAT 'CONST'
CONST   ENDS

BSS     SEGMENT PAGE PUBLIC FLAT 'BSS'
BSS     ENDS

STACK   SEGMENT PAGE STACK FLAT 'STACK'
STACK   ENDS

DGROUP  GROUP DATA,CONST,BSS,STACK
        ASSUME CS:FLAT,DS:FLAT,ES:FLAT,SS:FLAT

; includes the standard available things
        include macros.inc
        
.LIST

CODE    SEGMENT
        ;  These are defined in the startup module
        ;  Variables allocated in the startup.
        EXTERNDEF $$display:DWORD
        ;
        ;  Routines defined/created in the startup
        ;  The reason for this is that OS/2 routines do not kill the 
        ;  parameters on the stack after they return. 
        ;  The PASCAL std call mechanism does require this.
        EXTERNDEF  $DOS32OPEN:PROC
        EXTERNDEF  $DOS32CLOSE:PROC
        EXTERNDEF  $DOS32WRITE:PROC
        EXTERNDEF  $DOS32READ:PROC
        EXTERNDEF  $DOS32QUERYHTYPE:PROC
        EXTERNDEF  $DOS32EXIT:PROC
        EXTERNDEF  $DOS32ALLOCMEM:PROC
        EXTERNDEF  $DOS32FREEMEM:PROC
        EXTERNDEF  $DOS32SUBALLOC:PROC
        EXTERNDEF  $DOS32SUBFREE:PROC
        EXTERNDEF  $DOS32SUBSET:PROC
        EXTERNDEF  $DOS32SUBUNSET:PROC

        EXTERNDEF $$$memcpy:PROC
        EXTERNDEF $$memcpy:PROC
        EXTERNDEF $memcopy:PROC
        EXTERNDEF $$shl:PROC
        EXTERNDEF $$AndWord:PROC
        EXTERNDEF $$OrWord:PROC
        EXTERNDEF $$InvWord:PROC
        
        ;  Defined in the paslib
        EXTERNDEF  $$Stdodd:PROC
        EXTERNDEF  $$Stdintabs:PROC
        
        EXTERNDEF  $$StdInit:PROC
        EXTERNDEF  $$StdExit:PROC
        ;  From the I/O Lib
        ;  These names need to be rerouted since the backend uses the normal
        ;  generated names, but The library uses these descriptors.
        
        ;  File handles for the three files standard available in PASCAL
$output equ $_out_descr
$input  equ $_in_descr
$errout equ $_err_descr
        EXTERNDEF  $_out_descr:BYTE
        EXTERNDEF  $_in_descr:BYTE
        EXTERNDEF  $_err_descr:BYTE
        
        ;
        ;  Routines
        EXTERNDEF  $$StdWriteInt:PROC
        EXTERNDEF  $$StdWriteChar:PROC
        EXTERNDEF  $$StdWriteln:PROC
        EXTERNDEF  $errorlib:PROC
        EXTERNDEF  $errorlibcode:PROC
        EXTERNDEF  $$stdwriteln:PROC
        EXTERNDEF  $$stdwritechar:PROC
        EXTERNDEF  $$stdwritestring:PROC
        EXTERNDEF  $$stdwriteboolean:PROC
        EXTERNDEF  $$stdwriteint:PROC
        EXTERNDEF  $$stdreadln:PROC
        EXTERNDEF  $$stdreadchar:PROC
        EXTERNDEF  $$stdreadstring:PROC
        EXTERNDEF  $$stdreadint:PROC
        EXTERNDEF  $$stdassign:PROC
        EXTERNDEF  $$stdreset:PROC
        EXTERNDEF  $$stdrewrite:PROC
        EXTERNDEF  $$stdeoln:PROC
        EXTERNDEF  $$stdeof:PROC
        EXTERNDEF  $$stdget:PROC
        EXTERNDEF  $$stdput:PROC
        EXTERNDEF  $$StdReadBin:PROC
        EXTERNDEF  $$StdWriteBin:PROC
        ;
        ;  Routines from writelib.pas for very "elementary testing"
        ;  Some part of the testset only needs wrtoke,wrtwrong.
        ;  And they could even be implemented in assembler.
        EXTERNDEF  $wrtwrong:PROC
        EXTERNDEF  $wrtoke:PROC

        ;  From heaplib.pas
        EXTERNDEF  $_heap_start:DWORD
        EXTERNDEF  $_heap_size:DWORD
        EXTERNDEF  $$Stdnew:PROC
        EXTERNDEF  $$Stddispose:PROC
        
        ;  From Setlib.pas
        EXTERNDEF  $$SetInit:PROC
        EXTERNDEF  $$SetExit:PROC
        EXTERNDEF  $$StdGetSetConst:PROC
        EXTERNDEF  $$StdReleaseSetConst:PROC
        EXTERNDEF  $$StdSetSet:PROC
        EXTERNDEF  $$StdSetCpy:PROC
        EXTERNDEF  $$StdSetRange:PROC
        EXTERNDEF  $$StdSetUnion:PROC
        EXTERNDEF  $$StdSetDiff:PROC
        EXTERNDEF  $$StdSetInter:PROC
        EXTERNDEF  $$StdSetIn:PROC
        EXTERNDEF  $$StdSetEqual:PROC
        EXTERNDEF  $$StdSetIncl:PROC
        EXTERNDEF  $$StdWriteSet:PROC

CODE    ENDS
;*
;* $Log: pashead.inc,v $
; Revision 1.1  1993/11/03  15:54:52  wjw
; Started adminstration for the RUNTIME LIB
;
;*
;*      First created by Willem Jan Withagen ( wjw@eb.ele.tue.nl ),
;*                    on Mon July 26 23:30:03 MET 1993
;* 
